/*
 * Created on Nov 8, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.framework.agent;

import java.util.Collections;
import java.util.HashMap;
import java.util.Set;

/**
 * @author Lotzi Boloni
 * 
 * A generic implementation of a message.
 * 
 */
public class GenericMessage implements IMessage {
	private String destination;
	private final HashMap<String, Object> values = new HashMap<String, Object>();
	private int deliveryTime;
	private int sendingTime;

	/**
	 * @param destination
	 */
	public GenericMessage(String destination) {
		super();
		this.destination = destination;
	}

	public int getDeliveryTime() {
		return deliveryTime;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see yaes.framework.agent.IMessage#getDestination()
	 */
	public String getDestination() {
		return destination;
	}

	/**
	 * Returns a set of the fields of the message
	 * 
	 * @return
	 */
	public Set<String> getFields() {
		return Collections.unmodifiableSet(values.keySet());
	}

	public int getSendingTime() {
		return sendingTime;
	}

	public Object getValue(String name) {
		return values.get(name);
	}

	public void setDeliveryTime(int deliveryTime) {
		this.deliveryTime = deliveryTime;
	}

	public void setDestination(String destination) {
		this.destination = destination;
	}

	public void setSendingTime(int sendingTime) {
		this.sendingTime = sendingTime;
	}

	public void setValue(String name, Object o) {
		values.put(name, o);
	}

	@Override
	public String toString() {
		final StringBuffer buffer = new StringBuffer("Message to: "
				+ getDestination());
		for (final String element : values.keySet()) {
			buffer.append(element + " = " + values.get(element) + "\n");
		}
		return buffer.toString();
	}
}
