/*
 * Created on Sep 26, 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package yaes.framework.algorithm.pathplanning;

import java.util.Comparator;

import yaes.framework.algorithm.search.DestinationComparator;
import yaes.framework.algorithm.search.SortedFringe;
import yaes.framework.algorithm.search.TreeNodeComparator;
import yaes.framework.algorithm.search.TreeSearchNode;
import yaes.framework.world.map.IMap;
import yaes.framework.world.map.PlannedPath;

/**
 * @author Lotzi Boloni
 * 
 */
public class BestFirstPP extends AbstractTreePathPlanner {
	/**
	 * @param problemDescription
	 * @param problemSpace
	 */
	public BestFirstPP(PlannedPath problemDescription, IMap problemSpace) {
		super(problemDescription, problemSpace);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see simulation.algorithms.pathplanning.AbstractTreePathPlanner#initFringe()
	 */
	@Override
	@SuppressWarnings("unchecked")
	protected void initFringe() {
		final Comparator c1 = new DestinationComparator(thePath
				.getDestination());
		final Comparator<TreeSearchNode> c2 = new TreeNodeComparator(c1);
		theFringe = new SortedFringe(c2);
	}
}
