/*
 * Created on Dec 14, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package yaes.framework.simulation;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author Lotzi Boloni
 * 
 * This class provides an integration of the output parameters from a number of
 * simulations.
 * 
 */
public class IntegratedSOP {
	/**
	 * Integrates a set of simulation output parameters, by computing their
	 * average
	 * 
	 * @param sops
	 * @return
	 */
	public static SimulationOutput integrate(List<SimulationOutput> sops) {
		final SimulationOutput sop = new SimulationOutput(null, null);
		final SimulationOutput first = sops.get(0);
		// List<String> randomVariables = first.getRandomVariableNames();
		for (final Iterator<String> it = first.getParameterIterator(); it
				.hasNext();) {
			final String varName = it.next();
			for (final SimulationOutput element : sops) {
				sop.update(varName, element.getValue(varName,
						RandomVariable.Probe.AVERAGE));
			}
		}
		return sop;
	}

	/**
	 * Integrates a list of list of simulation output parameters -- the typical
	 * output of a simulationSet
	 * 
	 * @param listOflists
	 * @return
	 */
	public static List<SimulationOutput> integrateListOfSops(
			List<List<SimulationOutput>> listOflists) {
		final List<SimulationOutput> first = listOflists.get(0);
		final int size = first.size();
		final List<SimulationOutput> outputs = new ArrayList<SimulationOutput>();
		for (int i = 0; i != size; i++) {
			final List<SimulationOutput> prepared = new ArrayList<SimulationOutput>();
			for (final List<SimulationOutput> element : listOflists) {
				prepared.add(element.get(i));
			}
			final SimulationOutput sop = IntegratedSOP.integrate(prepared);
			outputs.add(sop);
		}
		return outputs;
	}
}