package yaes.ui.propertysheet.editors;

import java.util.Vector;

import yaes.ui.propertysheet.IntegerList;

public class IntegerListEditor extends ListEditor {
	private IntegerList dataList;

	public IntegerListEditor() {
	}

	@Override
	public boolean addOneToken(Vector list, String token) {
		boolean parseError = false;
		try {
			list.add(Integer.valueOf(token.trim()));
		} catch (final NumberFormatException exc) {
			parseError = true;
		}
		return parseError;
	}

	@Override
	public String getAsText() {
		return listToString(dataList);
	}

	@Override
	public Object getValue() {
		return dataList;
	}

	@Override
	public void setAsText(String s) {
		final Vector v = stringToList(s);
		if (v != null) {
			setValue(new IntegerList(v));
		}
	}

	@Override
	public void setValue(Object obj) {
		dataList = (IntegerList) obj;
		this.firePropertyChange();
	}
}