package yaes.ui.propertysheet.editors;

import java.beans.PropertyEditorSupport;
import java.lang.reflect.Field;
import java.util.logging.Level;

import yaes.ui.propertysheet.ErrorPresenter;

public class LogLevelEditor extends PropertyEditorSupport implements
		CustomEditorWidget {
	private final String[] tags;
	private final Field[] fields;

	public LogLevelEditor() {
		// Level sample = Level.SEVERE;
		final Class<Level> clazz = Level.class;
		fields = clazz.getFields();
		tags = new String[fields.length];
		for (int i = 0; i < fields.length; i++) {
			final Field field = fields[i];
			final String levelName = field.toString();
			final String logging = "logging.Level";
			final int index = levelName.lastIndexOf(logging);
			final String name = levelName.substring(index + logging.length()
					+ 1);
			tags[i] = new String(name);
		}
	}

	public void actionOk() {
	}

	@Override
	public String getAsText() {
		final Level level = (Level) getValue();
		return level.getName();
	}

	@Override
	public String[] getTags() {
		return tags;
	}

	public String getWidgetTitle() {
		return "Select Log Level";
	}

	@Override
	public void setAsText(String s) throws IllegalArgumentException {
		for (String element : tags) {
			if (element.equals(s)) {
				final Level level = Level.parse(element);
				setValue(level);
				break;
			}
		}
	}

	public void setErrorPresenter(ErrorPresenter errorPresenter) {
	}

	public boolean supportsEditingTaggedValues() {
		return false;
	};
}
