package yaestest.framework.entity.control.speedcontrol;

import junit.framework.TestCase;
import yaes.framework.entity.control.ControlException;
import yaes.framework.entity.control.ISpeedControl;
import yaes.framework.entity.control.ISpeedControllable;
import yaes.framework.entity.control.speedcontrol.PathFollowControl;
import yaes.framework.world.map.Acceleration;
import yaes.framework.world.map.Location;
import yaes.framework.world.map.PathGenerator;
import yaes.framework.world.map.PlannedPath;
import yaes.framework.world.map.Speed;

public class testPathFollowControl extends TestCase implements
		ISpeedControllable {
	private ISpeedControl controller;
	private Speed speed;
	private Location location;
	private double updateTime = 0.0;

	public void addControl(ISpeedControl controller) {
		this.controller = controller;
	}

	public void controlSpeed(Speed speed) {
		this.speed = speed;
		// TODO Auto-generated method stub
	}

	public Acceleration getAcceleration() {
		// TODO Auto-generated method stub
		return null;
	}

	public Location getLocation() {
		// TODO Auto-generated method stub
		return location;
	}

	public Speed getSpeed() {
		// TODO Auto-generated method stub
		return speed;
	}

	public void removeControl(ISpeedControl controller) {
		// TODO Auto-generated method stub
	}

	public void setLocation(Location location) {
		this.location = location;
	}

	public void testCustomPath() {
		// (27.0, 271.0)(28.0, 270.0)(29.0, 269.0)(30.0, 268.0)(31.0, 267.0)
		this.speed = new Speed(0, 0);
		final PlannedPath path = new PlannedPath();
		path.setSource(new Location(27.0, 271.0));
		path.addLocation(new Location(27.0, 271.0));
		path.addLocation(new Location(28.0, 270.0));
		path.addLocation(new Location(29.0, 269.0));
		path.addLocation(new Location(30.0, 268.0));
		path.setDestination(new Location(30.0, 268.0));
		final double speed = 1;
		System.out.println("======================");
		System.out.println("Test Custome path");
		System.out.println("speed:" + speed + " Custom Path:" + path);
		System.out.println("======================");
		final PathFollowControl pControl = new PathFollowControl(path, speed, 0);
		pControl.setControllable(this);
		this.addControl(pControl);
		this.location = path.getSource();
		for (int time = 1; time < 7; time++) {
			try {
				updateLocation(time);
				if (!path.containsLocation(location.getRoundedLocation())) {
					System.out.println("Warning:" + location
							+ "does not lie in path");
				}
			} catch (final Exception ex) {
				ex.printStackTrace();
			}
		}
	}

	public void testLinearPathInAllDirections() {
		wtestLinearPath(PathGenerator.generateLinearPath(new Location(10, 10),
				new Location(20, 20)));
		wtestLinearPath(PathGenerator.generateLinearPath(new Location(20, 20),
				new Location(10, 10)));
		wtestLinearPath(PathGenerator.generateLinearPath(new Location(10, 20),
				new Location(20, 10)));
		wtestLinearPath(PathGenerator.generateLinearPath(new Location(20, 10),
				new Location(10, 20)));
	}

	public void testThicklyPopulatedSinosidalPath() {
		final PlannedPath path = PathGenerator.generateSinosidalPath();
		final double speed = 0.5;
		System.out.println("======================");
		System.out.println("Test Sinosidal path");
		System.out.println("speed:" + speed + " Sinosidal Path:" + path);
		System.out.println("======================");
		final PathFollowControl pControl = new PathFollowControl(path, speed, 0);
		pControl.setControllable(this);
		this.addControl(pControl);
		this.location = path.getSource();
		for (int time = 0; time < 200; time++) {
			try {
				updateLocation(time);
			} catch (final Exception ex) {
				ex.printStackTrace();
			}
		}
	}

	public void testZigZagPath() {
		final PlannedPath path = PathGenerator.generateZigZagPath();
		final double speed = 0.2;
		System.out.println("======================");
		System.out.println("Test ZigZag path");
		System.out.println("speed:" + speed + " ZigZag Path:" + path);
		System.out.println("======================");
		final PathFollowControl pControl = new PathFollowControl(path, speed, 0);
		pControl.setControllable(this);
		this.addControl(pControl);
		this.location = path.getSource();
		for (int time = 0; time < 200; time++) {
			try {
				updateLocation(time);
				if (!path.containsLocation(location.getRoundedLocation())) {
					System.out.println("Warning:" + location
							+ "does not lie in path");
				}
			} catch (final Exception ex) {
				ex.printStackTrace();
			}
		}
	}

	public void updateLocation(double time) throws ControlException {
		if (controller != null) {
			controller.control(time);
		}
		// System.out.println("Location before update:"+ location);
		if (speed != null) {
			System.out.println("speed:" + speed.magnitude());
			final double deltaTime = time - updateTime;
			updateTime = time;
			final double xPos = location.getX() + speed.getXSpeed() * deltaTime;
			final double yPos = location.getY() + speed.getYSpeed() * deltaTime;
			location = new Location(xPos, yPos);
		}
		System.out.println("Location:" + location);
	}

	public void wtestLinearPath(PlannedPath path) {
		final double speed = 1;
		System.out.println("======================");
		System.out.println("Test Linear path");
		System.out.println("speed:" + speed + " Linear Path:" + path);
		System.out.println("======================");
		final PathFollowControl pControl = new PathFollowControl(path, speed, 0);
		pControl.setControllable(this);
		this.addControl(pControl);
		this.location = path.getSource();
		for (int time = 0; time < 100; time++) {
			try {
				updateLocation(time);
				if (!path.containsLocation(location.getRoundedLocation())) {
					System.out.println("Warning:" + location
							+ "does not lie in path");
				}
			} catch (final Exception ex) {
				ex.printStackTrace();
			}
		}
	}
}
